Index: doc-docbook/src/xml/osztaly-forma.xml
===================================================================
--- doc-docbook/src/xml/osztaly-forma.xml	(revision 126)
+++ doc-docbook/src/xml/osztaly-forma.xml	(revision 152)
@@ -1,22 +1,26 @@
-<etik:class>
- <etik:name> 
-  Osztaly neve
- </etik:name>
-
- <etik:description>
- Ez itt egy tobbsoros, tobb reszes leiras arrol, hogy altalanossagban
- mire is jo ez az osztaly.  Ez itt egy tobbsoros, tobb reszes leiras
- arrol, hogy altalanossagban mire is jo ez az osztaly.
-<para>
- Ez itt az uj bekezdese a leirasnak, mert elofordulhat, hogy tobb
- bekezdesre erdemes tagolni az iromanyt.
-</para>
- </etik:description>
-
- <etik:example>
-  Gyakran hasznos egy peldan bemutatni a mukodest. A kovetkezo egy
-  egyszeru kis szemleltetes arra, hogy ezt milyen konnyen es gyorsan
-  lehet hasznalni:
-<programlisting>
+<etik:class id="haho">
+  <etik:name> 
+    Osztály neve
+  </etik:name>
+
+  <etik:category>
+    Ez a category rész nem kötelezõ. Ide kerülhet például, hogy ez egy
+    konténer-osztály, vagy gráf-osztály.
+  </etik:category>
+ 
+  <etik:description>
+    A description egy kötelezõ rész.  Egy általános leírás arról, hogy
+    mire jó ez az osztály, és hogyan kell használni.
+    <para>
+      A description-be kerülhet új bekezdés is többek között.
+    </para>
+    <xref linkend="haho"/>
+  </etik:description>
+
+  <etik:example>
+    Az example nem kötelezõ, de ajánlott rész. Ide kerülhet egy
+    konkrét leírás, ha szükséges, utána pedig a programkód, mondjuk a
+    programlisting elementbe ágyazva:
+    <programlisting>
 
 struct eqstr
@@ -33,88 +37,164 @@
 }
 
-</programlisting>
-
-Vigyázat, a programlisting mód parsolt, és minden <![CDATA[<]]>-t értelmez!
-Elõnye, hogy lehet bele linkeket csinálni, de talán kényelmesebb egy LaTeX-szerû
-verbatim-mód, ezt valósítja meg az <![CDATA[<etik:code>]]> element.
-
-<etik:code>
-  int _i=1;
-  int _ii=1;
-  ListGraph::EdgeMap<int> my_edge_property(G);
-  for(EachEdgeIt i=G.first<EachEdgeIt>(); i.valid(); ++i) {
-    my_edge_property.set(i, _i);
-    _i*=_ii; ++_ii;
-  }
-</etik:code>
-</etik:example>
-
- <etik:definition>
-Ez a definition szekcio arra van, hogy beleirjuk, hogy milyen fajlban
-van definialva az aktualis osztaly.
-Ez <xref linkend="tutorial"/> egy link a tutorialra.
- </etik:definition>
-
-<etik:template_params>
-<etik:template_param>
-<etik:templ_name>
-T
-</etik:templ_name>
-<etik:templ_description>
-Ez itt a T parameter. Ebben adod meg hogy milyen izekbol epitsunk kupacot.
-</etik:templ_description>
-<etik:templ_requirement>
-Legyen implementalva neki az osszehasonlito operator.
-</etik:templ_requirement>
-<etik:templ_default>
-Az nincs
-</etik:templ_default>
-</etik:template_param>
-<etik:template_param>
-<etik:templ_name>
-Af
-</etik:templ_name>
-<etik:templ_description>
-Az Af template parameter is egy olyan vacak, ami a generikussaghoz kell.
-</etik:templ_description>
-<etik:templ_requirement>
-Af szarmazzon az elemi osztalyokbol.
-</etik:templ_requirement>
-<etik:templ_default>
-0
-</etik:templ_default>
-</etik:template_param>
-</etik:template_params>
-
-
-<etik:members>
-<etik:member>
-<etik:m_name>
-iterator
-</etik:m_name>
-<etik:m_where_def>
-container
-</etik:m_where_def>
-<etik:m_description>
-Arra valo, hogy vegigiteraljunk vele.
-</etik:m_description>
-
-</etik:member>
-<etik:member>
-<etik:m_name>
-void push_back(const T&)
-</etik:m_name>
-<etik:m_where_def>
-Back Insertion Sequence
-</etik:m_where_def>
-<etik:m_description>
-Egy uj element tesz e vegere.
-</etik:m_description>
-
-</etik:member>
-</etik:members>
-
-
-
+    </programlisting>
+
+    A programlisting környezetben használhatóak különbözõ linkek,
+    viszont vigyázat, a programlisting mód parsolt, és minden
+    <![CDATA[<]]>-t értelmez!
+
+      <para>
+        Az Emacs automata kiegészítõ, element bezáró és element
+        felajánló képességei rendkívül fontosak ilyen xml fájlok
+        készítésénél, különben túl sokat kell gépelni.  Egyelõre csak
+        olyan belül-nem-parsoló környezetet tudtam készíteni, ami az
+        xml-ben már nem szabványos, s az Emacs parsolója is kiakad
+        tõle. Így hát nincs olyan környezet, mint pl. a LaTeX
+        verbatim-ja. A kódokat egy CDATA blokkba kell beletenni, ami a
+        kövtekezõ képpen néz ki: &lt![CDATA[ ide jön a kód ]]&gt Az
+        eredetileg verbatim módnak szánt <![CDATA[<etik:code>]]>
+        element-nél szintén szükség van erre a CDATA blokkra, ha a
+        kódrész &lt vagy &gt karaktereket tartalmaz:
+      </para>
+
+      <etik:code>
+      <![CDATA[
+int _i=1;
+int _ii=1;
+ListGraph::EdgeMap<int> my_edge_property(G);
+ for(EachEdgeIt i=G.first<EachEdgeIt>(); i.valid(); ++i) {
+   my_edge_property.set(i, _i);
+   _i*=_ii; ++_ii;
+ }
+    ]]>
+    </etik:code>
+  </etik:example>
+
+  <etik:definition>
+    A Definition rész kötelezõ, és ide kerül az, hogy mely fájlban van
+    definiálva az osztály.
+  </etik:definition>
+
+  <etik:template_params>
+    <etik:template_param>
+      <etik:templ_name>
+        T
+      </etik:templ_name>
+      <etik:templ_description>
+        Ide kerül példának okáért a T paraméter leírása.
+      </etik:templ_description>
+      <etik:templ_requirement>
+        Ide kerülnek a feltételek az adott paraméterre. 
+      </etik:templ_requirement>
+      <etik:templ_default>
+        A default értéket is fel kell tüntetni.
+      </etik:templ_default>
+    </etik:template_param>
+    <etik:template_param>
+      <etik:templ_name>
+        A
+      </etik:templ_name>
+      <etik:templ_description>
+        Az Af template paraméter azért került ide, 
+        hogy látszódjon a táblázat.
+      </etik:templ_description>
+      <etik:templ_requirement>
+        Az Af-re vonatkozó feltételek.
+      </etik:templ_requirement>
+      <etik:templ_default>
+        0
+      </etik:templ_default>
+    </etik:template_param>
+  </etik:template_params>
+
+
+  <etik:members>
+    <etik:member>
+      <etik:m_name>
+        Egy tag
+      </etik:m_name>
+      <etik:m_where_def>
+        Pl. vmelyik õsében.
+      </etik:m_where_def>
+      <etik:m_description>
+        Leírás, hogy mire való, miért van.
+      </etik:m_description>
+    </etik:member>
+
+    <etik:member>
+      <etik:m_name>
+        Másik tag
+      </etik:m_name>
+      <etik:m_where_def>
+        Benne.
+      </etik:m_where_def>
+      <etik:m_description>
+        Leírás, hogy mire való, miért van.
+      </etik:m_description>
+    </etik:member>
+  </etik:members>
+
+
+  <etik:prot_members>
+    <etik:member>
+      <etik:m_name>
+        Egy tag
+      </etik:m_name>
+      <etik:m_where_def>
+        Pl. vmelyik õsében.
+      </etik:m_where_def>
+      <etik:m_description>
+        Leírás, hogy mire való, miért van.
+      </etik:m_description>
+    </etik:member>
+
+    <etik:member>
+      <etik:m_name>
+        Másik tag
+      </etik:m_name>
+      <etik:m_where_def>
+        Benne.
+      </etik:m_where_def>
+      <etik:m_description>
+        Leírás, hogy mire való, miért van.
+      </etik:m_description>
+    </etik:member>
+  </etik:prot_members>
+
+  <etik:priv_members>
+    <etik:member>
+      <etik:m_name>
+        Egy tag
+      </etik:m_name>
+      <etik:m_where_def>
+        Pl. vmelyik õsében.
+      </etik:m_where_def>
+      <etik:m_description>
+        Leírás, hogy mire való, miért van.
+      </etik:m_description>
+    </etik:member>
+
+    <etik:member>
+      <etik:m_name>
+        Másik tag
+      </etik:m_name>
+      <etik:m_where_def>
+        Benne.
+      </etik:m_where_def>
+      <etik:m_description>
+        Leírás, hogy mire való, miért van.
+      </etik:m_description>
+    </etik:member>
+  </etik:priv_members>
+
+
+  <etik:notes>
+    Megjegyzések: nem kötelezõ rész. A fenti 4 táblázat mind
+    opcionális. Ha nincsenek protected tagok, akkor az a táblázat
+    nyugodtan kimaradhat. A felhasználói doksiban pl. semmi szükség
+    az utolsó kettõre, de ez más kérdés.
+    <para>
+      Ebbe a részbe is kerülhet új bekezdés, vagy pl. felsorolás.
+    </para>
+  </etik:notes>
 
 </etik:class>
@@ -132,5 +212,5 @@
 sgml-indent-step:2
 sgml-indent-data:nil
-sgml-parent-document:("graph-classes.xml" "sect1" "etik:class")
+sgml-parent-document:("graph-classes.xml" "section" "etik:class")
 sgml-exposed-tags:nil
 sgml-local-catalogs:nil